/* Developed by Fabrice Bline */
/* Cemagref */
/* Aout 2004 */

#include "stdio.h"

#define P1_T rpar[0]/24
#define P1_F rpar[1]
#define P1_A rpar[2]
#define P1_W rpar[3]
#define P2_T rpar[4]/24
#define P2_F rpar[5]
#define P2_A rpar[6]
#define P2_W rpar[7]
#define P3_T rpar[8]/24
#define P3_F rpar[9]
#define P3_A rpar[10]
#define P3_W rpar[11]
#define P4_T rpar[12]/24
#define P4_F rpar[13]
#define P4_A rpar[14]
#define P4_W rpar[15]

void IAP_Cycle(int * flag, int *nevprt, double* t, double* xd, double* x,
	     int* nx, double* z, int *nz, double* tvec, int* ntvec,
	     double* rpar, int* nrpar, int* ipar, int* nipar, double* y1,
	     int* ny1)

{
  int nb_cycle;
  float cycle;
  float Tps_Cycle;

  if (*flag==1||*flag==6)
    {
      cycle= P1_T + P2_T + P3_T + P4_T;
      nb_cycle=*t/cycle;
      Tps_Cycle=*t-nb_cycle*cycle;

      if (Tps_Cycle<=P1_T)
	{
	  y1[0]=P1_F;
	  y1[1]=P1_A;
	  y1[2]=P1_W;
	}
      else
	{
	  if (Tps_Cycle<=(P1_T+P2_T))
	    {
	      y1[0]=P2_F;
	      y1[1]=P2_A;
	      y1[2]=P2_W;	  
	    }
	  else
	    {
	      if (Tps_Cycle<=(P1_T+P2_T+P3_T))
		{
		  y1[0]=P3_F;
		  y1[1]=P3_A;
		  y1[2]=P3_W;	  
		}
	      else
		{
		  y1[0]=P4_F;
		  y1[1]=P4_A;
		  y1[2]=P4_W;	 
		}
	    }
	}
    }
  return;
}

