mode(-1);

disp('Loading ASModel1.0 contribution');
disp('');

// generic part  
// get the absolute path 
[units,typs,nams]=file();
clear units typs
for k=size(nams,'*'):-1:1 
  l=strindex(nams(k),'loader.sce');
  if l<>[] then
    DIR=part(nams(k),1:l($)-1);
    break
  end
end
//---------------------------------------------------------------------
// Under Unix and Linux systems
//---------------------------------------------------------------------
if ~MSDOS then
	if part(DIR,1)<>'/' then
		DIR=getcwd()+'/'+DIR
	end

	SRC=DIR+'src/'
	MACROS=DIR+'macros/'
	DATA=DIR+'data/'

	link(+SRC+'IAPreacteur_ASM1.o','IAPreacteur_ASM1','C');
	link(+SRC+'Influent_ASM1.o','Influent_ASM1','C');
	link(+SRC+'IAP_Cycle.o','IAP_Cycle','C');
	link(+SRC+'ASM1_Demux.o','ASM1_Demux','C');
	link(+SRC+'Influent_PiWaT1.o','Influent_PiWaT1','C');
	link(+SRC+'PiWaT1_Demux.o','PiWaT1_Demux','C');
	link(+SRC+'IAPreacteur_PiWaT1.o','IAPreacteur_PiWaT1','C');

//---------------------------------------------------------------------
// Under Windows systems
//---------------------------------------------------------------------
else
 	if part(DIR,2)<>':' then
		DIR=getcwd()+'\'+DIR
	end

	SRC=DIR+'src\'
	MACROS=DIR+'macros\'
	DATA=DIR+'data\'

	link(+SRC+'IAPreacteur_ASM1.dll','IAPreacteur_ASM1','C');
	link(+SRC+'Influent_ASM1.dll','Influent_ASM1','C');
	link(+SRC+'IAP_Cycle.dll','IAP_Cycle','C');
	link(+SRC+'ASM1_Demux.dll','ASM1_Demux','C');
	link(+SRC+'Influent_PiWaT1.dll','Influent_PiWaT1','C');
	link(+SRC+'PiWaT1_Demux.dll','PiWaT1_Demux','C');
	link(+SRC+'IAPreacteur_PiWaT1.dll','IAPreacteur_PiWaT1','C');

end

   // load the library
getf(+MACROS+'Influent_ASM1.sci');
getf(+MACROS+'IAPreacteur_ASM1.sci');
getf(+MACROS+'IAP_Cycle.sci');
getf(+MACROS+'ASM1_Demux.sci');
getf(+MACROS+'Influent_PiWaT1.sci');
getf(+MACROS+'PiWaT1_Demux.sci');
getf(+MACROS+'IAPreacteur_PiWaT1.sci');

 // Add palette

chdir(SRC);
errcatch(-1,'continue','nomessage');
load('.scicos_pal')
if iserror(-1) then errclear(-1);end
scicos_pal=[scicos_pal; ['ASModel',+DIR+'ASModel.cos'] ]	
[x,k]=gsort(scicos_pal(:,2))
keq=find(x(2:$)==x(1:$-1))
k(keq)=[];k=-sort(-k);
scicos_pal=scicos_pal(k,:);
errcatch(-1,'continue')
save('.scicos_pal',scicos_pal)
if iserror(-1) then
  errclear(-1)
  message('Cannot save .scicos_pal in current directory')
end

disp('');
disp('ASModel1.0 is loaded Enjoy it!!! ');
disp('');

chdir(DATA);

//clean environment
clear DIR SRC MACROS DATA

scicos();


