// Developed by Fabrice Bline
// Cemagref
// Aout 2004
function [x,y,typ]=IAPreacteur_PiWaT1(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)

case 'set' then,

  x=arg1;
  graphics=arg1.graphics;
  exprs=graphics.exprs;
  model=arg1.model;

 exprs1=[exprs(1);exprs(2);exprs(3);exprs(4);exprs(5);exprs(6)];
 exprs2=[exprs(7); exprs(8); exprs(9); exprs(10); exprs(11); exprs(12); exprs(13); exprs(14); exprs(15); exprs(16); exprs(17); exprs(18)];
 exprs3=[exprs(19);exprs(20); exprs(21); exprs(22);exprs(23);exprs(24);exprs(25);exprs(26)];
 exprs4=[exprs(27);exprs(28);exprs(29)];
 exprs5=[exprs(30)];
 exprs6=[exprs(31)];
 exprs7_1=[exprs(32);exprs(33);exprs(34); exprs(35);exprs(36);exprs(37);exprs(38);exprs(39);exprs(40);exprs(41);exprs(42);exprs(43);exprs(44);exprs(45);exprs(46);exprs(47)];
 exprs7_2=[exprs(48);exprs(49)];


  n=1;
 
  n=x_choose(['Stoichiometric constants';'Kinetic constants (Heterotrophic)';'Kinetic constants (Autotrophic)';'Aeration capacity';'Temperature';'Withdrawal flow rate';'Initial states'],['Menu'])

  if n==1 then,
  while %t do
	[ok, Yh, Yhd, Yai, Yaa, fp, ibn, exprs1]=getvalue('Stoichiometric constants - Model PiWaT1',..
	['Aerobic heterotrophic yield - Yh (gDCO/gDCO)';
	'Anoxic heterotrophic yield - Yhd (gDCO/gDCO)';
	'Ammonium oxidisers yield - Yai (gDCO/gN)';
	'Nitrite oxidisers yield - Yaa (gDCO/gN)';
	'Inert fraction of biomass - fp (-)';
	'Nitrogen content of active biomass - ibn (gN/gDCO)'],..
	list('vec',1,..
	     'vec',1,..
	     'vec',1,..
	     'vec',1,..
	     'vec',1,..
	     'vec',1),..
	      exprs1)
  if ~ok then break , end
  if ok then,
	model.rpar(1)=Yh;
	model.rpar(2)=Yhd;
	model.rpar(3)=Yai;
	model.rpar(4)=Yaa;
	model.rpar(5)=fp;
	model.rpar(6)=ibn;
	graphics.exprs(1)=exprs1(1);
	graphics.exprs(2)=exprs1(2);
	graphics.exprs(3)=exprs1(3);
	graphics.exprs(4)=exprs1(4);
	graphics.exprs(5)=exprs1(5);
	graphics.exprs(6)=exprs1(6);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end



  if n==2 then,
  while %t do
	[ok, muh, bh, Koh, Kad, Ks, Knoi, Knoa, ng, Knh, Kh, nh, ka, exprs2]=getvalue('Kinetic constants (Heterotrophic) - Model PiWaT1',..
	['Heterotrophic max. specific growth rate - muh (1/d)';
	'Heterotrophic decay rate - bh (1/d)';
	'Aerobic oxygen half-saturation coefficient for heterotrophs - Koh (gO2/m3)';
	'Anoxic oxygen half-saturation coefficient for heterotrophs - Kad (gO2/m3)';
	'Ss half-saturation coefficient for heterotrophs - Ks (gDCO/m3)';
	'Nitrite half-saturation coefficient for heterotrophs - Knoi (gN/m3)';
	'Nitrate half-saturation coefficient for heterotrophs - Knoa (gN/m3)';
	'Anoxic growth factor reduction - ng (-)';
	'Snh half-saturation coefficient - Knh (gN/m3)';
	'Xs max. specific hydrolysis rate - Kh (gDCO/(gDCO.d))';
	'Anoxic hydrolysis factor reduction - nh (-)';
	'Ammonification rate - ka (m3.DCO/(g.d))'],..
	    list('vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	    exprs2)
  if ~ok then break , end
  if ok then,
	model.rpar(7)=muh;
	model.rpar(8)=bh;
	model.rpar(9)=Koh;
	model.rpar(10)=Kad;
	model.rpar(11)=Ks;
	model.rpar(12)=Knoi;
	model.rpar(13)=Knoa;
	model.rpar(14)=ng;
	model.rpar(15)=Knh;
	model.rpar(16)=Kh;
	model.rpar(17)=nh;
	model.rpar(18)=ka;
	graphics.exprs(7)=exprs2(1);
	graphics.exprs(8)=exprs2(2);
	graphics.exprs(9)=exprs2(3);
	graphics.exprs(10)=exprs2(4);
	graphics.exprs(11)=exprs2(5);
	graphics.exprs(12)=exprs2(6);
	graphics.exprs(13)=exprs2(7);
	graphics.exprs(14)=exprs2(8);
	graphics.exprs(15)=exprs2(9);
	graphics.exprs(16)=exprs2(10);
	graphics.exprs(17)=exprs2(11);
	graphics.exprs(18)=exprs2(12);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end


  if n==3 then,

  while %t do

  [ok, muai, bai, Knai, Koai, muaa, baa, Knaa, Koaa, exprs3]=getvalue('Kinetic constants (Autotrophic) - Model PiWaT1',..
	['Ammonium oxidisers max. specific growth rate - muai (1/d)';
	'Ammonium oxidisers decay rate - bai (1/d)';
	'Ammonium half-saturation coefficient for Ammonium oxidisers - Knai (gN/m3)';
	'Oxygen half-saturation coefficient for Ammonium oxidisers - Koai (gO2/m3)';
	'Nitrite oxidisers max. specific growth rate - muaa (1/d)';
	'Nitrite oxidisers decay rate - baa (1/d)';
	'Nitrite half-saturation coefficient for Nitrite oxidisers - Knaa (gN/m3)';
	'Oxygen half-saturation coefficient for Nitrite oxidisers - Koaa (gO2/m3)'],..
	   list('vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	      exprs3)

  if ~ok then break , end

  if ok then,
	model.rpar(19)=muai;
	model.rpar(20)=bai;
	model.rpar(21)=Knai;
	model.rpar(22)=Koai;
	model.rpar(23)=muaa;
	model.rpar(24)=baa;
	model.rpar(25)=Knaa;
	model.rpar(26)=Koaa;
	graphics.exprs(19)=exprs3(1);
	graphics.exprs(20)=exprs3(2);
	graphics.exprs(21)=exprs3(3);
	graphics.exprs(22)=exprs3(4);
	graphics.exprs(23)=exprs3(5);
	graphics.exprs(24)=exprs3(6);
	graphics.exprs(25)=exprs3(7);
	graphics.exprs(26)=exprs3(8);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end

  if n==4 then,

  while %t do

  [ok, Kla, Alpha, Beta, exprs4]=getvalue(' Aeration capacity',..
	['Mass transfer coefficient - Kla (1/d)';
	'Alpha factor (-)';
	'Beta factor (-)'],..
	  list('vec',1,..
	    'vec',1,..
	    'vec',1),..
	      exprs4)

  if ~ok then break , end

  if ok then,
	model.rpar(27)=Kla;
	model.rpar(28)=Alpha;
	model.rpar(29)=Beta;
	graphics.exprs(27)=exprs4(1);
	graphics.exprs(28)=exprs4(2);
	graphics.exprs(29)=exprs4(3);
	x.graphics=graphics;
	x.model=model;
	break;
  end
  end
  end


  if n==5 then,

  while %t do

		[ok,Temperature,exprs5]=getvalue('Temperature',..
       		     ['Temperature (Deg. Celcius)'],..
		    list('vec',1),..
		    exprs5)

  if ~ok then break , end

 if ok then,
	model.rpar(30)=Temperature;
	graphics.exprs(30)=exprs5(1);
	x.graphics=graphics;
	x.model=model;	
	break;
 end
 end
 end

if n==6 then,

 while %t do

	[ok,Qs,exprs6]=getvalue('Flow rate',..
	['Withdrawal flow rate (m3/h)'],..
	   list('vec',1),..
	   exprs6)

  if ~ok then break , end

  if ok then,
	model.rpar(31)=Qs;
	graphics.exprs(31)=exprs6(1);
	x.graphics=graphics;
	x.model=model;	
	break;
  end
  end
  end


  if n==7 then,

  m=1;
 
  m=x_choose(['Use initial states';'Use files'],['Menu'])

  if m==1 then,
  while %t do
   [ok, Si, Ss, Xi, Xs, Xbh, Xbai, Xbaa, Xp, So, Snoi, Snoa, Snh, Snd, Xnd, Xni, Volume, exprs7_1]=getvalue('Initial states',..
	['Soluble inert COD Si (gDCO/m3)';
	'Readily biodegradable COD - Ss (gDCO/m3)';
	'Particulate inert COD - Xi (gDCO/m3)';
	'Slowly Biodegradable COD - Xs (gDCO/m3)';
	'Active heterotrophic biomass - Xbh (gDCO/m3)';
	'Active ammonium oxidizing biomass - Xbai (gDCO/m3)';
	'Active nitrite oxidizing biomass - Xbaa (gDCO/m3)';
	'Particulate inert COD from biomass - Xp (gDCO/m3)';
	'Dissolved oxygen - So (gO2/m3)';
	'Nitrite - Snoi (gN/m3)';
	'Nitrate - Snoa (gN/m3)';
	'Ammonium+ammonia - Snh (gN/m3)';
	'Soluble organic nitrogen - Snd (gN/m3)';
	'Particulate organic nitrogen - Xnd (gN/m3)';
	'Particulate inert organic nitrogen - Xni (gN/m3)';
	'Volume (m3)'],..
	    list('vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1,..
	    'vec',1),..
	    exprs7_1)
  
  if ~ok then break , end

  if ok then,
   	x0=[Si; Ss; Xi; Xs; Xbh; Xbai ;Xbaa ; Xp; So; Snoi; Snoa; Snh; Snd; Xnd; Xni; Volume];
   	model.state=x0(:);
	graphics.exprs(32)=exprs7_1(1);
	graphics.exprs(33)=exprs7_1(2);
	graphics.exprs(34)=exprs7_1(3);
	graphics.exprs(35)=exprs7_1(4);
	graphics.exprs(36)=exprs7_1(5);
	graphics.exprs(37)=exprs7_1(6);
	graphics.exprs(38)=exprs7_1(7);
	graphics.exprs(39)=exprs7_1(8);
	graphics.exprs(40)=exprs7_1(9);
	graphics.exprs(41)=exprs7_1(10);
	graphics.exprs(42)=exprs7_1(11);
	graphics.exprs(43)=exprs7_1(12);
	graphics.exprs(44)=exprs7_1(13);
	graphics.exprs(45)=exprs7_1(14);
	graphics.exprs(46)=exprs7_1(15);	
	graphics.exprs(47)=exprs7_1(16);
  	x.graphics=graphics;
  	x.model=model;
   break;
  end
  end
  end

  if m==2 then,
  while %t do
   [ok, FILE_OUT, FILE_IN,exprs7_2]=getvalue('Use files',..
	['Save final states (0/1)';
	'Load initial states (0/1)'],..
	    list('vec',1,..
	    'vec',1),..
	    exprs7_2)
  
  if ~ok then break , end

  if ok then,
	model.rpar(32)=FILE_OUT;
	model.rpar(33)=FILE_IN;
	graphics.exprs(48)=exprs7_2(1);
	graphics.exprs(49)=exprs7_2(2);
  	x.graphics=graphics;
  	x.model=model;
   break;
  end
  end
  end
  end

  case 'define' then
  Yh=0.6;
  Yhd=0.53;
  Yai=0.15;
  Yaa=0.041;
  fp=0.08;
  ibn=0.086;

  muh=6.0;
  bh=0.62;
  Koh=0.05;
  Kad=0.05;
  Ks=20;
  Knoi=0.5;
  Knoa=0.5;
  ng=0.8;
  Knh=0.05;
  Kh=10;
  nh=0.4;
  ka=0.08;

  muai=0.8;
  bai=0.05;
  Knai=5;
  Koai=0.3;
  muaa=0.79;
  baa=0.033;
  Knaa=2.5;
  Koaa=1.1;


  Kla=3000;
  Alpha=0.8;
  Beta=0.95;

  Temperature=20;

  Qs=20;

  Si=30;
  Ss=10;
  Xi=10;
  Xs=15;
  Xbh=500;
  Xbai=50;
  Xbaa=50;
  Xp=10;
  So=1;
  Snoi=10;
  Snoa=10;
  Snh=10;
  Snd=10;
  Xnd=10;
  Xni=10;
  Volume=200;

  FILE_OUT=0;
  FILE_IN=0;

  x0=[Si; Ss; Xi; Xs; Xbh; Xbai; Xbaa; Xp; So; Snoi; Snoa; Snh; Snd; Xnd; Xni; Volume]
  rpar=[Yh;Yhd;Yai;Yaa;fp;ibn;muh;bh;Koh;Kad;Ks;Knoi;Knoa;ng;Knh;Kh;nh;ka;muai;bai;Knai;Koai;muaa;baa;Knaa;Koaa;Kla;Alpha;Beta;Temperature;Qs;FILE_OUT;FILE_IN];
  in=[16;3];out=[16;1]

  model=scicos_model()
  model.sim=list('IAPreacteur_PiWaT1',1)
  model.in=in
  model.out=out
  model.evtin=[]
  model.state=x0(:)
  model.rpar=rpar;
  model.blocktype='c'
  model.dep_ut=[%f %t]

  exprs=[string(Yh);
  	string(Yhd);
  	string(Yai);
	string(Yaa);
	string(fp);
	string(ibn);
	string(muh);
	string(bh);
	string(Koh);
	string(Kad);
	string(Ks);
	string(Knoi);
	string(Knoa);
	string(ng);
	string(Knh);
	string(Kh);
	string(nh);
	string(ka);
	string(muai);
	string(bai);
	string(Knai);
	string(Koai);
	string(muaa);
	string(baa);
	string(Knaa);
	string(Koaa);
	string(Kla);
	string(Alpha);
	string(Beta);
	string(Temperature);
	string(Qs);
	string(Si);
	string(Ss);
	string(Xi);
	string(Xs);
	string(Xbh);
	string(Xbai);
	string(Xbaa);
	string(Xp);
	string(So);
	string(Snoi);
	string(Snoa);
	string(Snh);
	string(Snd);
	string(Xnd);
	string(Xni);
	string(Volume);
        string(FILE_OUT);
        string(FILE_IN)]


  gr_i=list(['thick=xget(''thickness'');';
	'pat=xget(''pattern'');';
	'fnt=xget(''font'');';
	'xset(''font'',fnt(1),2);';
 	'xset(''pattern'',scs_color(1));';
	'xstringb(orig(1)+0.17*sz(1),orig(2)+0.32*sz(2),''Cycle [3]'',0,0);';
	'xstringb(orig(1)+0.22*sz(1),orig(2)+0.66*sz(2),''Influent [16]'',0,0);';
	'xstringb(orig(1)+0.8*sz(1),orig(2)+0.32*sz(2),''Volume [1]'',0,0);';
	'xstringb(orig(1)+0.78*sz(1),orig(2)+0.66*sz(2),''Effluent [16]'',0,0);';
 	'xset(''pattern'',scs_color(2));';
	'xset(''font'',fnt(1),4);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.85*sz(2),''IAP Reactor'',0,0);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.15*sz(2),''PiWaT1'',0,0);';
	'xset(''font'',fnt(1),1);';
	'xset(''pattern'',pat);'],5)

  x=standard_define([6 8],model,exprs,gr_i);
end
endfunction
