// Developed by Fabrice Bline
// Cemagref
// Aout 2004
function [x,y,typ]=PiWaT1_Demux(job,arg1,arg2)
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then
  x=arg1
case 'define' then
  in=[16];out=[1;1;8;6]

  model=scicos_model()
  model.sim=list('PiWaT1_Demux',1)
  model.in=in
  model.out=out
  model.blocktype='c'
  model.dep_ut=[%t %f]

  exprs=[]
  gr_i=list(['thick=xget(''thickness'');';
	'pat=xget(''pattern'');';
	'fnt=xget(''font'');';
	'xset(''font'',fnt(1),1);';
 	'xset(''pattern'',scs_color(1));';
	'xstringb(orig(1)+0.7*sz(1),orig(2)+0.18*sz(2),''Nitrogen [6]'',0,0);';
	'xstringb(orig(1)+0.8*sz(1),orig(2)+0.39*sz(2),''COD [8]'',0,0);';
	'xstringb(orig(1)+0.7*sz(1),orig(2)+0.59*sz(2),''Flow rate [1]'',0,0);';
	'xstringb(orig(1)+0.7*sz(1),orig(2)+0.8*sz(2),''Oxygen [1]'',0,0);';
	'xstringb(orig(1)+0.28*sz(1),orig(2)+0.5*sz(2),''Effluent [16]'',0,0);';
 	'xset(''pattern'',scs_color(2));';
	'xset(''font'',fnt(1),2);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.05*sz(2),''Demux'',0,0);';
	'xstringb(orig(1)+0.5*sz(1),orig(2)+0.95*sz(2),''Effluent PiWaT1'',0,0);';
	'xset(''font'',fnt(1),1);';
	'xset(''pattern'',pat);'],5)
  x=standard_define([4 8],model,exprs,gr_i)
end
endfunction
